var VacmanDialogs = function() {

    function initDialog(dialog) {
        dialog.find("[name=cancelButton]").click(function(e) {
            e.preventDefault();
            hide();
        });

        dialog.find("[name=submitButton]").click(function(e) {
            e.preventDefault();
            getForm().submit();
            AJS.dialog2(dialog).hide();
        });

        function getElement(query) {
            return dialog.find(query);
        }

        function getElementByName(name) {
            return getElement("[name=" + name + "]");
        }
        
        function getForm() {
            return getElementByName("mainForm");
        }

        function show() {
            AJS.dialog2(dialog).show();
        }

        function hide() {
            AJS.dialog2(dialog).hide();
        }

        return {
            getElement : getElement,
            getElementByName : getElementByName,
            getForm : getForm,
            show : show,
            hide : hide
        }
    }

    function initAndCreateDialog(dialogToInit) {
        var dialog = AJS.$(dialogToInit);
        AJS.$("body").append(dialog);

        return initDialog(dialog);
    }

    function initExistingDialog(query) {
        return initDialog(AJS.$(query));
    }

    return {
        initAndCreateDialog : initAndCreateDialog,
        initExistingDialog : initExistingDialog
    }

}();
