AJS.$(document).ready(function() {

	var vacmanCalendar = null;
	var uid = 0;

	function addHolidayOntoCalendar(id, date, yearly, title) {
		prepareEventObjects(id, date, yearly, title).forEach(function(event) {
			vacmanCalendar.fullCalendar('renderEvent', event, true);
		});
	}
	
	function prepareEventObjects(id, date, yearly, title) {
		var events = new Array();
		if (yearly) {
			for (var year=2010; year<=2030; year++) { 
				var ndate = VM$.moment(date.year(year));
				var eventData = {
					id: id,
					uid: uid++,
					mainEvent: true,
					title: title,
					start: ndate,
					allDay: true,
					yearly: yearly,
					color: '#257e4a',
            		color: '#c8f1b9',
            		textColor: '#707070',
            		borderColor: '#257e4a'
				};
				events.push(eventData);
            	eventData = {
					id: id,
					mainEvent: false,
					start: ndate,
					allDay: true,
            		rendering: 'background',
            		color: '#f1bbbb'
        		};
            	events.push(eventData);
			}
		} else {
			var eventData = {
				id: id,
				uid: uid++,
				mainEvent: true,
				title: title,
				start: date,
				allDay: true,
				yearly: yearly,
        		color: '#c4ebff',
        		textColor: '#707070',
        		borderColor: '#3a87ad'
			};
			events.push(eventData);
        	eventData = {
				id: id,
				mainEvent: false,
				start: date,
				allDay: true,
        		rendering: 'background',
        		color: '#f1bbbb'
    		};
        	events.push(eventData);
		}
		return events;
	}
	
	function insertHolidays(holidays) {
		var events = new Array();
		holidays.forEach(function(holiday) {
			events = events.concat(prepareEventObjects(holiday.id, VM$.moment(holiday.date), holiday.yearly, holiday.description));
		});
		vacmanCalendar.fullCalendar( 'addEventSource', events );
	}

	function renderHolidaysTable() {
		AJS.$("#holidays-list").empty();
		var now = VM$.moment();
		var renderEvents = new Array();
		vacmanCalendar.fullCalendar('clientEvents', function(event) {
            if (event.start.year() == tableDate.year() && event.mainEvent == true) {
            	renderEvents.push({id:event.uid, start: event.start.format(), title: event.title, date: event.start,
            		yearly: event.yearly, past: event.start.isBefore(now), currentMonth: event.start.month() == tableDate.month()});
            }
            return false;
        });
		renderEvents.sort(function(a, b) {
			if (a.date > b.date) return 1;
			if (a.date < b.date) return -1;
			return 0;
		});
		AJS.$("#holidays-list").html(VacationManager.Templates.Workdays.Holidays.HolidayTable.holidaysTable({events:renderEvents, editable: editable}));
		
		AJS.$("[holiday-list-add-new]").click(function() {
		    HolidayDialogs.showAddHolidayDialog();
		});
		
		AJS.$("[holiday-list-clickable]").click(function() {
			var date = vacmanCalendar.fullCalendar('getCalendar').moment(AJS.$(this).attr("date"));
			vacmanCalendar.fullCalendar( 'gotoDate', date );
		    $('html, body').animate({
		        scrollTop: $("#vacman-calendar").offset().top
		    }, 100);
		});

		AJS.$("[holiday-list-edit]").click(function(evt) {
			var eventId = AJS.$(this).attr("event-id");
			vacmanCalendar.fullCalendar('clientEvents').forEach(function(event) {
				if (event.uid == eventId) {
				    HolidayDialogs.showEditHolidayDialog(event);
					evt.preventDefault();
					evt.stopPropagation();
				}
			});
		});

	}

	var tableDate = null;
	var customButtons = {};
	if (editable == true) {
        customButtons = {
            addNew: {
                text: AJS.I18n.getText("vacationmanager.action.holiday.holidays.add.label"),
                click: function() {
                    HolidayDialogs.showAddHolidayDialog();
                }
            }
        };
	}

	vacmanCalendar = VM$('#vacman-calendar').fullCalendar({
		header: {
			left: 'addNew',
			center: 'prevYear,prev title next,nextYear',
			right: 'today'
		},
		firstDay: firstDay,
		aspectRatio: 1.7,
		businessHours: {dow: daysOfWork},
	    dayClick: function(date, jsEvent, view) {
	        if (editable == true) {
	            HolidayDialogs.showAddHolidayDialog(date);
	        }
	    },
		eventClick: function(calEvent, jsEvent, view) {
		    if (editable == true) {
		        HolidayDialogs.showEditHolidayDialog(calEvent);
		    }
		},
		viewRender: function(view, element) {
			if (vacmanCalendar != null && tableDate.diff(vacmanCalendar.fullCalendar('getDate')) != 0) {
				tableDate = vacmanCalendar.fullCalendar('getDate');
				renderHolidaysTable();
			}
		},
		customButtons: customButtons
	});
	
	insertHolidays(holidays);
	
	tableDate = vacmanCalendar.fullCalendar('getDate');
	renderHolidaysTable();

	AJS.$('.aui-date-picker').each(function() {
		AJS.$(this).datePicker({'overrideBrowserDefault': true});
	});

    HolidayDialogs.initAddHolidayDialog(allHolidaySchemeIds, holidaySchemeId, function(obj) {
        if (obj.length > 0) {
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].holidaySchemeId == holidaySchemeId) {
                    obj = obj[i];
                    break;
                }
            }
        }
        addHolidayOntoCalendar(obj.id, VM$.moment(obj.date), obj.yearly, obj.description);
        renderHolidaysTable();        
    });
    
    HolidayDialogs.initEditHolidayDialog(function(obj) {
        vacmanCalendar.fullCalendar('removeEvents', obj.id);
        addHolidayOntoCalendar(obj.id, VM$.moment(obj.date), obj.yearly, obj.description);
        renderHolidaysTable();        
    });
    
    HolidayDialogs.initRemoveHolidayDialog(function(id) {
        vacmanCalendar.fullCalendar('removeEvents', id);
        renderHolidaysTable();
    });
    
    HolidaySchemeDialogs.initEditHolidaySchemeNameDialog();
    HolidaySchemeDialogs.initDeleteHolidaySchemeDialog();
	
});
